Attribute VB_Name = "modMain"
Public Function GetCustomers_ADO(DriverName As String, _
                                 ServerName As String, _
                                 WhereClause As String) As CustomerCollection
    Dim objCustomers As CustomerCollection
    Dim objCustomer As CustomerClass
    Set objCustomers = New CustomerCollection
    
    Dim cn As ADODB.Connection
    Dim qryCustomers As ADODB.Command
    Dim qryOrders As ADODB.Command
    Dim paramCustomerID As ADODB.Parameter
    Dim rsCustomers As ADODB.Recordset
    Dim rsOrders As ADODB.Recordset
    
    Set cn = New ADODB.Connection
    cn.CursorLocation = adUseNone
    cn.ConnectionString = "Provider=SQL Native Client;" & _
                          ";Server=" & ServerName & _
                          ";Database=Northwind;" & _
                          "Trusted_Connection=Yes;"
    cn.Open
    
    Set qryCustomers = New ADODB.Command
    Set qryCustomers.ActiveConnection = cn
    qryCustomers.CommandText = "SELECT CustomerID, CompanyName, ContactName, Phone" & _
                               " FROM Customers" & _
                               " WHERE " & WhereClause & _
                               " ORDER BY CompanyName"
                       
    Set qryOrders = New ADODB.Command
    Set qryOrders.ActiveConnection = cn
    qryOrders.CommandText = "SELECT OrderID, OrderDate FROM Orders" & _
                            " WHERE CustomerID = ?"
    Set paramCustomerID = qryOrders.CreateParameter
    paramCustomerID.Name = "@CustomerID"
    paramCustomerID.Type = adWChar
    paramCustomerID.Size = 5
    qryOrders.Parameters.Append paramCustomerID
    
    Set rsCustomers = qryCustomers.Execute
    
    Do While Not rsCustomers.EOF
        Set objCustomer = objCustomers.Add(rsCustomers!CustomerID, _
                                           rsCustomers!CompanyName, _
                                           rsCustomers!ContactName, _
                                           rsCustomers!Phone, _
                                           New OrderCollection)
        
        paramCustomerID.Value = objCustomer.CustomerID
        Set rsOrders = qryOrders.Execute
        Do While Not rsOrders.EOF
            objCustomer.Orders.Add rsOrders!OrderID, _
                                   rsOrders!OrderDate, _
                                   objCustomer
            rsOrders.MoveNext
        Loop
        rsOrders.Close
                     
        rsCustomers.MoveNext
    Loop
    rsCustomers.Close
    cn.Close
    
    Set GetCustomers_ADO = objCustomers
End Function
